Index: shlexec.c
===================================================================
RCS file: /home/wine/wine/dlls/shell32/shlexec.c,v
retrieving revision 1.53
diff -u -p -r1.53 shlexec.c
--- shlexec.c	16 Aug 2004 23:18:36 -0000	1.53
+++ shlexec.c	13 Sep 2004 18:13:00 -0000
@@ -77,6 +77,7 @@ static const WCHAR wszEmpty[] = {0};
  * %* all following parameters (see batfile)
  *
  * FIXME: use 'len'
+ * FIXME: Careful of going over string-boundries. No checking is done to 'res'...
  */
 static BOOL SHELL_ArgifyW(WCHAR* out, int len, const WCHAR* fmt, const WCHAR* lpFile, LPITEMIDLIST pidl, LPCWSTR args)
 {
@@ -85,6 +86,13 @@ static BOOL SHELL_ArgifyW(WCHAR* out, in
     PWSTR   res = out;
     PCWSTR  cmd;
     LPVOID  pv;
+    WCHAR   tmpBuffer[1024];
+    PWSTR   tmpB = tmpBuffer;
+    WCHAR   tmpEnvBuff[MAX_PATH];
+    WCHAR*  tmpE = tmpEnvBuff;
+    DWORD   envRet;
+    static const WCHAR wszSPerc[] = {'%','s',0};
+    static const WCHAR wszPerc[] = {'%',0};
 
     TRACE("%p, %d, %s, %s, %p, %p\n", out, len, debugstr_w(fmt),
           debugstr_w(lpFile), pidl, args);
@@ -178,8 +186,36 @@ static BOOL SHELL_ArgifyW(WCHAR* out, in
 		}
                 break;
 
-            default: FIXME("Unknown escape sequence %%%c\n", *fmt);
+	      default:
+	    /*
+	     * Check if this is a env-variable here...
+	     */
+
+	    /* Make sure that we have at least one more %.*/
+	    if (strstrW(fmt, wszPerc))
+	    {
+			while (*fmt != '%')
+				*tmpB++ = *fmt++;
+			*tmpB++ = 0;
+
+			TRACE("Checking %s to be a env-var\n", debugstr_w(tmpBuffer));
+
+			envRet = GetEnvironmentVariableW(tmpBuffer, tmpE, MAX_PATH);
+			if (envRet == 0 || envRet > MAX_PATH)
+			{
+				TRACE("The env. var can't be found or is bigger than MAX_PATH => useless.");
+				res += sprintfW(res, wszSPerc, tmpBuffer);
             }
+			else
+			{
+				TRACE("Found it %s. Replacing... \n", debugstr_w(tmpEnvBuff));
+				res += sprintfW(res, wszSPerc, tmpEnvBuff);
+			}
+		}
+
+	    } /* switch */
+
+
             fmt++;
             done = TRUE;
         }
@@ -342,7 +378,7 @@ static UINT SHELL_ExecuteW(const WCHAR *
     TRACE("returning %u\n", retval);
 
     psei_out->hInstApp = (HINSTANCE)retval;
-    if( gcdret ) 
+    if( gcdret )
         if( !SetCurrentDirectoryW( curdir))
             ERR("cannot return to directory %s\n", debugstr_w(curdir));
 
@@ -1234,7 +1270,7 @@ BOOL WINAPI ShellExecuteExW32 (LPSHELLEX
     if (retval > 32)  /* Found */
     {
         WCHAR wszQuotedCmd[MAX_PATH+2];
-        /* Must quote to handle case where cmd contains spaces, 
+        /* Must quote to handle case where cmd contains spaces,
          * else security hole if malicious user creates executable file "C:\\Program"
          */
         strcpyW(wszQuotedCmd, wQuote);
